<?php

/**
 * Questo file è parte del plugin WooCommerce v3.x di Fattura24
 * Autore: Fattura24.com <info@fattura24.com> 
 *
 * Chiamata API a TicketHD per inviare ticket a F24
 * 
 */
namespace fattura24;

if (!defined('ABSPATH')) exit;

/**
 * cfr: https://gist.github.com/sirbrillig/6ab49aa6517d203a6560d75d65e0874a
 */
function fatt_24_send_ticket($content)
{
    $pid = 'P-' . (string) $content['account_id'];
    $today = fatt_24_now(); // aggiungo data e orario utilizzando il CEST
    $fileName = plugin_dir_path(__FILE__) . 'att'. fatt_24_rand() . '_' .$today .'.txt';
    // cfr: https://stackoverflow.com/questions/2628798/print-array-to-a-file
    file_put_contents($fileName, print_r($content, true));
    $boundary = wp_generate_password(24);
    $headers = array('Content-Type' => 'multipart/form-data; boundary=' . $boundary);
    $formData = '--' . $boundary;
    $formData .= "\r\n";
    $formData .= 'Content-Disposition: form-data; name="widget_id"' . "\r\n\r\n";
    $formData .= $pid;
    $formData .= "\r\n";
    $formData .= '--' . $boundary;
    $formData .= "\r\n";
    $formData .= 'Content-Disposition: form-data; name="name"' . "\r\n\r\n";
    $formData .= $content['username'];
    $formData .= "\r\n";
    $formData .= '--' . $boundary;
    $formData .= "\r\n";
    $formData .= 'Content-Disposition: form-data; name="email"' . "\r\n\r\n";
    $formData .= $content['email'];
    $formData .= "\r\n";
    $formData .= '--' . $boundary;
    $formData .= "\r\n";
    $formData .= 'Content-Disposition: form-data; name="text"' . "\r\n\r\n";
    $formData .= $content['text'];
    $formData .= "\r\n";
    $formData .= '--' . $boundary;
    $formData .= "\r\n";
    $formData .= 'Content-Disposition: form-data; name="file";  filename="' . basename($fileName) .'"' . "\r\n";
    $formData .= "\r\n";
    $formData .= file_get_contents($fileName);
    $formData .= "\r\n";
    $formData .= '--' . $boundary . '--';
    $url = 'https://www.desktale.com/api/server/tickets/sendTicket?api_key=fis4xr6FH4Gfhk7rTDFsd2wq3ZdfD3cgjB7ds3sDMnp5';
    $request = wp_remote_post($url, 
        array(
            'method' => 'POST',
            'timeout' => 60,
            'httpversion' => '1.0',
            'blocking' => true,
            'headers' => $headers,
            'body' => $formData,
            'cookies' => array()
        )
    );
    $body = is_wp_error($request)? json_encode($request) : wp_remote_retrieve_body($request);
    unlink($fileName);
    return $body;
    
}